import { sharedConfig as y, createRenderEffect as E, untrack as N, splitProps as q, createMemo as P, onCleanup as Y, $TRACK as oe, batch as se, createRoot as R, createSignal as I, createResource as O, useTransition as re, createEffect as le, mergeProps as Q, createComponent as T, Suspense as ce, Show as fe, Index as ae } from "solid-js";
import { getHighlighterCore as ue } from "shiki";
import './index.css';const de = [
  "allowfullscreen",
  "async",
  "autofocus",
  "autoplay",
  "checked",
  "controls",
  "default",
  "disabled",
  "formnovalidate",
  "hidden",
  "indeterminate",
  "inert",
  "ismap",
  "loop",
  "multiple",
  "muted",
  "nomodule",
  "novalidate",
  "open",
  "playsinline",
  "readonly",
  "required",
  "reversed",
  "seamless",
  "selected"
], he = /* @__PURE__ */ new Set([
  "className",
  "value",
  "readOnly",
  "formNoValidate",
  "isMap",
  "noModule",
  "playsInline",
  ...de
]), ge = /* @__PURE__ */ new Set([
  "innerHTML",
  "textContent",
  "innerText",
  "children"
]), me = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(null), {
  className: "class",
  htmlFor: "for"
}), ye = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(null), {
  class: "className",
  formnovalidate: {
    $: "formNoValidate",
    BUTTON: 1,
    INPUT: 1
  },
  ismap: {
    $: "isMap",
    IMG: 1
  },
  nomodule: {
    $: "noModule",
    SCRIPT: 1
  },
  playsinline: {
    $: "playsInline",
    VIDEO: 1
  },
  readonly: {
    $: "readOnly",
    INPUT: 1,
    TEXTAREA: 1
  }
});
function we(n, t) {
  const e = ye[n];
  return typeof e == "object" ? e[t] ? e.$ : void 0 : e;
}
const xe = /* @__PURE__ */ new Set([
  "beforeinput",
  "click",
  "dblclick",
  "contextmenu",
  "focusin",
  "focusout",
  "input",
  "keydown",
  "keyup",
  "mousedown",
  "mousemove",
  "mouseout",
  "mouseover",
  "mouseup",
  "pointerdown",
  "pointermove",
  "pointerout",
  "pointerover",
  "pointerup",
  "touchend",
  "touchmove",
  "touchstart"
]), be = /* @__PURE__ */ new Set([
  "altGlyph",
  "altGlyphDef",
  "altGlyphItem",
  "animate",
  "animateColor",
  "animateMotion",
  "animateTransform",
  "circle",
  "clipPath",
  "color-profile",
  "cursor",
  "defs",
  "desc",
  "ellipse",
  "feBlend",
  "feColorMatrix",
  "feComponentTransfer",
  "feComposite",
  "feConvolveMatrix",
  "feDiffuseLighting",
  "feDisplacementMap",
  "feDistantLight",
  "feDropShadow",
  "feFlood",
  "feFuncA",
  "feFuncB",
  "feFuncG",
  "feFuncR",
  "feGaussianBlur",
  "feImage",
  "feMerge",
  "feMergeNode",
  "feMorphology",
  "feOffset",
  "fePointLight",
  "feSpecularLighting",
  "feSpotLight",
  "feTile",
  "feTurbulence",
  "filter",
  "font",
  "font-face",
  "font-face-format",
  "font-face-name",
  "font-face-src",
  "font-face-uri",
  "foreignObject",
  "g",
  "glyph",
  "glyphRef",
  "hkern",
  "image",
  "line",
  "linearGradient",
  "marker",
  "mask",
  "metadata",
  "missing-glyph",
  "mpath",
  "path",
  "pattern",
  "polygon",
  "polyline",
  "radialGradient",
  "rect",
  "set",
  "stop",
  "svg",
  "switch",
  "symbol",
  "text",
  "textPath",
  "tref",
  "tspan",
  "use",
  "view",
  "vkern"
]), Ce = {
  xlink: "http://www.w3.org/1999/xlink",
  xml: "http://www.w3.org/XML/1998/namespace"
};
function Ae(n, t, e) {
  let i = e.length, o = t.length, r = i, c = 0, s = 0, l = t[o - 1].nextSibling, d = null;
  for (; c < o || s < r; ) {
    if (t[c] === e[s]) {
      c++, s++;
      continue;
    }
    for (; t[o - 1] === e[r - 1]; )
      o--, r--;
    if (o === c) {
      const f = r < i ? s ? e[s - 1].nextSibling : e[r - s] : l;
      for (; s < r; )
        n.insertBefore(e[s++], f);
    } else if (r === s)
      for (; c < o; )
        (!d || !d.has(t[c])) && t[c].remove(), c++;
    else if (t[c] === e[r - 1] && e[s] === t[o - 1]) {
      const f = t[--o].nextSibling;
      n.insertBefore(e[s++], t[c++].nextSibling), n.insertBefore(e[--r], f), t[o] = e[r];
    } else {
      if (!d) {
        d = /* @__PURE__ */ new Map();
        let a = s;
        for (; a < r; )
          d.set(e[a], a++);
      }
      const f = d.get(t[c]);
      if (f != null)
        if (s < f && f < r) {
          let a = c, w = 1, m;
          for (; ++a < o && a < r && !((m = d.get(t[a])) == null || m !== f + w); )
            w++;
          if (w > f - s) {
            const g = t[c];
            for (; s < f; )
              n.insertBefore(e[s++], g);
          } else
            n.replaceChild(e[s++], t[c++]);
        } else
          c++;
      else
        t[c++].remove();
    }
  }
}
const B = "_$DX_DELEGATE";
function Se(n, t, e) {
  let i;
  const o = () => {
    const c = document.createElement("template");
    return c.innerHTML = n, c.content.firstChild;
  }, r = () => (i || (i = o())).cloneNode(!0);
  return r.cloneNode = r, r;
}
function z(n, t = window.document) {
  const e = t[B] || (t[B] = /* @__PURE__ */ new Set());
  for (let i = 0, o = n.length; i < o; i++) {
    const r = n[i];
    e.has(r) || (e.add(r), t.addEventListener(r, ke));
  }
}
function v(n, t, e) {
  y.context && n.isConnected || (e == null ? n.removeAttribute(t) : n.setAttribute(t, e));
}
function pe(n, t, e, i) {
  y.context && n.isConnected || (i == null ? n.removeAttributeNS(t, e) : n.setAttributeNS(t, e, i));
}
function k(n, t) {
  y.context && n.isConnected || (t == null ? n.removeAttribute("class") : n.className = t);
}
function Ee(n, t, e, i) {
  if (i)
    Array.isArray(e) ? (n[`$$${t}`] = e[0], n[`$$${t}Data`] = e[1]) : n[`$$${t}`] = e;
  else if (Array.isArray(e)) {
    const o = e[0];
    n.addEventListener(t, e[0] = (r) => o.call(n, e[1], r));
  } else
    n.addEventListener(t, e);
}
function Te(n, t, e = {}) {
  const i = Object.keys(t || {}), o = Object.keys(e);
  let r, c;
  for (r = 0, c = o.length; r < c; r++) {
    const s = o[r];
    !s || s === "undefined" || t[s] || (G(n, s, !1), delete e[s]);
  }
  for (r = 0, c = i.length; r < c; r++) {
    const s = i[r], l = !!t[s];
    !s || s === "undefined" || e[s] === l || !l || (G(n, s, !0), e[s] = l);
  }
  return e;
}
function Me(n, t, e) {
  if (!t)
    return e ? v(n, "style") : t;
  const i = n.style;
  if (typeof t == "string")
    return i.cssText = t;
  typeof e == "string" && (i.cssText = e = void 0), e || (e = {}), t || (t = {});
  let o, r;
  for (r in e)
    t[r] == null && i.removeProperty(r), delete e[r];
  for (r in t)
    o = t[r], o !== e[r] && (i.setProperty(r, o), e[r] = o);
  return e;
}
function J(n, t = {}, e, i) {
  const o = {};
  return i || E(
    () => o.children = _(n, t.children, o.children)
  ), E(
    () => typeof t.ref == "function" ? Z(t.ref, n) : t.ref = n
  ), E(() => Ne(n, t, e, !0, o, !0)), o;
}
function Z(n, t, e) {
  return N(() => n(t, e));
}
function $e(n, t, e, i) {
  if (e !== void 0 && !i && (i = []), typeof t != "function")
    return _(n, t, i, e);
  E((o) => _(n, t(), o, e), i);
}
function Ne(n, t, e, i, o = {}, r = !1) {
  t || (t = {});
  for (const c in o)
    if (!(c in t)) {
      if (c === "children")
        continue;
      o[c] = H(n, c, null, o[c], e, r);
    }
  for (const c in t) {
    if (c === "children")
      continue;
    const s = t[c];
    o[c] = H(n, c, s, o[c], e, r);
  }
}
function _e(n) {
  let t, e;
  return !y.context || !(t = y.registry.get(e = Pe())) ? n() : (y.completed && y.completed.add(t), y.registry.delete(e), t);
}
function Le(n) {
  return n.toLowerCase().replace(/-([a-z])/g, (t, e) => e.toUpperCase());
}
function G(n, t, e) {
  const i = t.trim().split(/\s+/);
  for (let o = 0, r = i.length; o < r; o++)
    n.classList.toggle(i[o], e);
}
function H(n, t, e, i, o, r) {
  let c, s, l, d, f;
  if (t === "style")
    return Me(n, e, i);
  if (t === "classList")
    return Te(n, e, i);
  if (e === i)
    return i;
  if (t === "ref")
    r || e(n);
  else if (t.slice(0, 3) === "on:") {
    const a = t.slice(3);
    i && n.removeEventListener(a, i), e && n.addEventListener(a, e);
  } else if (t.slice(0, 10) === "oncapture:") {
    const a = t.slice(10);
    i && n.removeEventListener(a, i, !0), e && n.addEventListener(a, e, !0);
  } else if (t.slice(0, 2) === "on") {
    const a = t.slice(2).toLowerCase(), w = xe.has(a);
    if (!w && i) {
      const m = Array.isArray(i) ? i[0] : i;
      n.removeEventListener(a, m);
    }
    (w || e) && (Ee(n, a, e, w), w && z([a]));
  } else if (t.slice(0, 5) === "attr:")
    v(n, t.slice(5), e);
  else if ((f = t.slice(0, 5) === "prop:") || (l = ge.has(t)) || !o && ((d = we(t, n.tagName)) || (s = he.has(t))) || (c = n.nodeName.includes("-"))) {
    if (f)
      t = t.slice(5), s = !0;
    else if (y.context && n.isConnected)
      return e;
    t === "class" || t === "className" ? k(n, e) : c && !s && !l ? n[Le(t)] = e : n[d || t] = e;
  } else {
    const a = o && t.indexOf(":") > -1 && Ce[t.split(":")[0]];
    a ? pe(n, a, t, e) : v(n, me[t] || t, e);
  }
  return e;
}
function ke(n) {
  const t = `$$${n.type}`;
  let e = n.composedPath && n.composedPath()[0] || n.target;
  for (n.target !== e && Object.defineProperty(n, "target", {
    configurable: !0,
    value: e
  }), Object.defineProperty(n, "currentTarget", {
    configurable: !0,
    get() {
      return e || document;
    }
  }), y.registry && !y.done && (y.done = _$HY.done = !0); e; ) {
    const i = e[t];
    if (i && !e.disabled) {
      const o = e[`${t}Data`];
      if (o !== void 0 ? i.call(e, o, n) : i.call(e, n), n.cancelBubble)
        return;
    }
    e = e._$host || e.parentNode || e.host;
  }
}
function _(n, t, e, i, o) {
  const r = !!y.context && n.isConnected;
  if (r) {
    !e && (e = [...n.childNodes]);
    let l = [];
    for (let d = 0; d < e.length; d++) {
      const f = e[d];
      f.nodeType === 8 && f.data.slice(0, 2) === "!$" ? f.remove() : l.push(f);
    }
    e = l;
  }
  for (; typeof e == "function"; )
    e = e();
  if (t === e)
    return e;
  const c = typeof t, s = i !== void 0;
  if (n = s && e[0] && e[0].parentNode || n, c === "string" || c === "number") {
    if (r)
      return e;
    if (c === "number" && (t = t.toString()), s) {
      let l = e[0];
      l && l.nodeType === 3 ? l.data !== t && (l.data = t) : l = document.createTextNode(t), e = M(n, e, i, l);
    } else
      e !== "" && typeof e == "string" ? e = n.firstChild.data = t : e = n.textContent = t;
  } else if (t == null || c === "boolean") {
    if (r)
      return e;
    e = M(n, e, i);
  } else {
    if (c === "function")
      return E(() => {
        let l = t();
        for (; typeof l == "function"; )
          l = l();
        e = _(n, l, e, i);
      }), () => e;
    if (Array.isArray(t)) {
      const l = [], d = e && Array.isArray(e);
      if (j(l, t, e, o))
        return E(() => e = _(n, l, e, i, !0)), () => e;
      if (r) {
        if (!l.length)
          return e;
        if (i === void 0)
          return [...n.childNodes];
        let f = l[0], a = [f];
        for (; (f = f.nextSibling) !== i; )
          a.push(f);
        return e = a;
      }
      if (l.length === 0) {
        if (e = M(n, e, i), s)
          return e;
      } else
        d ? e.length === 0 ? F(n, l, i) : Ae(n, e, l) : (e && M(n), F(n, l));
      e = l;
    } else if (t.nodeType) {
      if (r && t.parentNode)
        return e = s ? [t] : t;
      if (Array.isArray(e)) {
        if (s)
          return e = M(n, e, i, t);
        M(n, e, null, t);
      } else
        e == null || e === "" || !n.firstChild ? n.appendChild(t) : n.replaceChild(t, n.firstChild);
      e = t;
    }
  }
  return e;
}
function j(n, t, e, i) {
  let o = !1;
  for (let r = 0, c = t.length; r < c; r++) {
    let s = t[r], l = e && e[n.length], d;
    if (!(s == null || s === !0 || s === !1))
      if ((d = typeof s) == "object" && s.nodeType)
        n.push(s);
      else if (Array.isArray(s))
        o = j(n, s, l) || o;
      else if (d === "function")
        if (i) {
          for (; typeof s == "function"; )
            s = s();
          o = j(
            n,
            Array.isArray(s) ? s : [s],
            Array.isArray(l) ? l : [l]
          ) || o;
        } else
          n.push(s), o = !0;
      else {
        const f = String(s);
        l && l.nodeType === 3 && l.data === f ? n.push(l) : n.push(document.createTextNode(f));
      }
  }
  return o;
}
function F(n, t, e = null) {
  for (let i = 0, o = t.length; i < o; i++)
    n.insertBefore(t[i], e);
}
function M(n, t, e, i) {
  if (e === void 0)
    return n.textContent = "";
  const o = i || document.createTextNode("");
  if (t.length) {
    let r = !1;
    for (let c = t.length - 1; c >= 0; c--) {
      const s = t[c];
      if (o !== s) {
        const l = s.parentNode === n;
        !r && !c ? l ? n.replaceChild(o, s) : n.insertBefore(o, e) : l && s.remove();
      } else
        r = !0;
    }
  } else
    n.insertBefore(o, e);
  return [o];
}
function Pe() {
  const n = y.context;
  return `${n.id}${n.count++}`;
}
const Ie = "http://www.w3.org/2000/svg";
function ve(n, t = !1) {
  return t ? document.createElementNS(Ie, n) : document.createElement(n);
}
function Oe(n) {
  const [t, e] = q(n, ["component"]), i = P(() => t.component);
  return P(() => {
    const o = i();
    switch (typeof o) {
      case "function":
        return N(() => o(e));
      case "string":
        const r = be.has(o), c = y.context ? _e() : ve(o, r);
        return J(c, e, r), c;
    }
  });
}
function U(n) {
  var t;
  for (let e = 0; e < n.length; e++)
    (t = n[e]) == null || t.disposer();
}
function Ve(n, t, e = {}) {
  const i = [];
  let o = [], r, c, s, l, d, f, a, w, m;
  return Y(() => {
    m == null || m(), m = void 0, U(i);
  }), () => {
    const h = n() || [];
    return h[oe], N(() => {
      var S, p, $, D;
      h.length > 0 && m && (m(), m = void 0, w = void 0);
      const u = new Array(h.length);
      for (r = i.length, s = r - 1; s >= 0; --s)
        l = i[s], f = l.index, f < h.length && h[f] === l.value && (u[f] = o[f], --r !== s && (i[s] = i[r], i[r] = l));
      const b = /* @__PURE__ */ new Map(), C = new Uint8Array(r);
      for (s = r - 1; s >= 0; --s)
        d = i[s].value, ((S = b.get(d)) == null ? void 0 : S.push(s)) ?? b.set(d, [s]);
      for (c = 0; c < h.length; ++c)
        c in u || (a = h[c], s = ((p = b.get(a)) == null ? void 0 : p.pop()) ?? -1, s >= 0 && (l = i[s], f = l.index, u[c] = o[f], l.index = c, ($ = l.indexSetter) == null || $.call(l, c), C[s] = 1));
      for (s = C.length - 1; s >= 0; --s)
        C[s] && --r !== s && (l = i[s], i[s] = i[r], i[r] = l);
      for (s = r - 1; s >= 0; --s)
        l = i[s], f = l.index, !(f in u) && f < h.length && (u[f] = o[f], a = h[f], l.value = a, (D = l.valueSetter) == null || D.call(l, g), --r !== s && (i[s] = i[r], i[r] = l));
      for (c = 0; c < h.length; ++c)
        c in u || (a = h[c], r > 0 ? (l = i[--r], u[c] = o[l.index], se(x)) : u[c] = R(A));
      return U(i.splice(0, r)), h.length === 0 && e.fallback ? (m || (w = [
        R((ie) => (m = ie, e.fallback()))
      ]), w) : o = u;
    });
  };
  function g() {
    return a;
  }
  function x() {
    var h, u;
    l.index = c, (h = l.indexSetter) == null || h.call(l, c), l.value = a, (u = l.valueSetter) == null || u.call(l, g);
  }
  function A(h) {
    const u = {
      value: a,
      index: c,
      disposer: h
    }, b = a, C = c;
    i.push(u);
    let S = () => ([S, u.valueSetter] = I(b, { name: "value" }), S()), p = () => ([p, u.indexSetter] = I(C, { name: "index" }), p());
    return t(
      () => S(),
      () => p()
    );
  }
}
function je(n) {
  const t = "fallback" in n && { fallback: () => n.fallback };
  return P(
    Ve(() => n.each, n.children, t || void 0),
    void 0,
    { name: "value" }
  );
}
function ee(n) {
  var t, e, i = "";
  if (typeof n == "string" || typeof n == "number")
    i += n;
  else if (typeof n == "object")
    if (Array.isArray(n)) {
      var o = n.length;
      for (t = 0; t < o; t++)
        n[t] && (e = ee(n[t])) && (i && (i += " "), i += e);
    } else
      for (e in n)
        n[e] && (i && (i += " "), i += e);
  return i;
}
function De() {
  for (var n, t, e = 0, i = "", o = arguments.length; e < o; e++)
    (n = arguments[e]) && (t = ee(n)) && (i && (i += " "), i += t);
  return i;
}
const Re = "index-module__editor___WoVwR", Be = "index-module__container___GdQY1", Ge = "index-module__character___mhd0f", He = "index-module__textarea___cMW-q", L = {
  editor: Re,
  container: Be,
  character: Ge,
  textarea: He
};
function Fe(n) {
  let t = parseInt(n.slice(1), 16), e = t >> 16 & 255, i = t >> 8 & 255, o = t & 255;
  return [e, i, o];
}
function Ue(n, t, e) {
  n /= 255, t /= 255, e /= 255;
  const i = Math.max(n, t, e), o = Math.min(n, t, e);
  let r = (i + o) / 2, c = (i + o) / 2, s = (i + o) / 2;
  if (i === o)
    r = c = 0;
  else {
    const l = i - o;
    switch (c = s > 0.5 ? l / (2 - i - o) : l / (i + o), i) {
      case n:
        r = (t - e) / l + (t < e ? 6 : 0);
        break;
      case t:
        r = (e - n) / l + 2;
        break;
      case e:
        r = (n - t) / l + 4;
        break;
    }
    r /= 6;
  }
  return [r, c, s];
}
function Ke(n, t, e) {
  let i, o, r;
  if (t === 0)
    i = o = r = e;
  else {
    const c = (d, f, a) => (a < 0 && (a += 1), a > 1 && (a -= 1), a < 0.16666666666666666 ? d + (f - d) * 6 * a : a < 0.5 ? f : a < 0.6666666666666666 ? d + (f - d) * (0.6666666666666666 - a) * 6 : d), s = e < 0.5 ? e * (1 + t) : e + t - e * t, l = 2 * e - s;
    i = c(l, s, n + 1 / 3), o = c(l, s, n), r = c(l, s, n - 1 / 3);
  }
  return [Math.round(i * 255), Math.round(o * 255), Math.round(r * 255)];
}
function K(n, t, e) {
  const i = [n, t, e].map((o) => (o /= 255, o <= 0.03928 ? o / 12.92 : Math.pow((o + 0.055) / 1.055, 2.4)));
  return i[0] * 0.2126 + i[1] * 0.7152 + i[2] * 0.0722;
}
function We(n, t) {
  const e = K(...n), i = K(...t), o = Math.max(e, i), r = Math.min(e, i);
  return (o + 0.05) / (r + 0.05);
}
const W = /* @__PURE__ */ new Map();
function Xe(n) {
  const t = W.get(n);
  if (t)
    return t;
  const e = Fe(n);
  let i = e, o = Ue(i[0], i[1], i[2]);
  const r = o[2] < 0.5;
  let c = 0, s = 0;
  for (; s < 200 && (o[2] += r ? 1e-3 : -1e-3, !(o[2] <= 0 || o[2] >= 1 || (i = Ke(o[0], o[1], o[2]), c = We(i, e), c > 4.5))); )
    s++;
  const l = `#${((1 << 24) + (i[0] << 16) + (i[1] << 8) + i[2]).toString(16).slice(1).toUpperCase()}`;
  return W.set(n, l), l;
}
function te(n, t, e) {
  const i = typeof n == "function" ? n() : n;
  return i ? t(i) : e ? e() : void 0;
}
function qe(n, t, e) {
  return () => te(n, t, e);
}
function Ye(...n) {
  function t() {
    const e = new Array(n.length);
    for (let i = 0; i < n.length; i++) {
      const o = typeof n[i] == "function" ? n[i]() : n[i];
      if (!o)
        return;
      e[i] = o;
    }
    return e;
  }
  return t;
}
function Qe(n) {
  return n.split(`
`).length;
}
function ze(n) {
  let t = -1 / 0;
  return n.split(`
`).forEach((e) => {
    e.length > t && (t = e.length);
  }), t;
}
var Je = /* @__PURE__ */ Se("<div><div><textarea inputmode=none autocomplete=off></textarea><code aria-hidden>");
async function X(n) {
  if (n instanceof Promise) {
    const t = await n;
    return "default" in t ? t.default : t;
  }
  return n;
}
const Ze = import("./wasm-SPaT1zC5.js"), V = /* @__PURE__ */ new WeakMap();
function et([n, t]) {
  let e = V.get(n);
  e || (V.set(n, /* @__PURE__ */ new WeakMap()), e = V.get(n));
  let i = e.get(t);
  return i || (i = ue({
    themes: [n],
    langs: [t],
    loadWasm: Ze
  }), e.set(t, i)), i;
}
function it(n) {
  const [t, e] = q(n, ["class", "defaultValue", "lang", "onInput", "value", "style", "theme"]), [i, o] = I(t.defaultValue || t.value), [r, c] = I({
    width: 0,
    height: 0
  }), [s] = O(() => t.theme, X), [l] = O(() => t.lang, X), [d] = O(Ye(s, l), et), f = P((g) => {
    var C;
    const x = d(), A = (C = N(l)) == null ? void 0 : C[0], h = N(s);
    if (!x || !A || !h)
      return g;
    const u = i();
    if (!i)
      return;
    const b = x.codeToHast(u, {
      lang: A.name,
      theme: h
    });
    return b.children[0] ? b.children[0] : g;
  }), a = qe(s, (g) => {
    try {
      if (!g.colors)
        throw "no colors present in theme";
      if (!g.colors["editor.background"])
        throw "no background color present";
      return {
        "--theme-selection-color": Xe(g.colors["editor.background"]),
        "--theme-background-color": g.colors["editor.background"],
        "--theme-foreground-color": g.colors.foreground
      };
    } catch (x) {
      console.error("error", x);
      return;
    }
  }), [, w] = re();
  function m(g) {
    w(() => o(g));
  }
  return le(() => m(t.value)), (() => {
    var g = Je(), x = g.firstChild, A = x.firstChild, h = A.nextSibling;
    return J(g, Q({
      get class() {
        return De(L.editor, t.class);
      },
      get style() {
        return {
          ...a(),
          ...t.style
        };
      }
    }, e), !1, !0), $e(x, T(ce, {
      get children() {
        return T(je, {
          get each() {
            return te(f, (u) => "children" in u && u.children);
          },
          children: (u) => T(ne, {
            get node() {
              return u();
            }
          })
        });
      }
    }), A), A.$$input = ({
      currentTarget: {
        value: u
      }
    }) => m(u), v(A, "spellcheck", !1), Z((u) => {
      const b = new ResizeObserver(([C]) => {
        c(C.contentRect);
      });
      b.observe(u), Y(() => b.disconnect());
    }, h), h.innerHTML = "&nbsp;", E((u) => {
      var b = L.container, C = `${Math.ceil(ze(i()) * r().width + 1)}px`, S = `${Math.ceil(Qe(i()) * r().height)}px`, p = L.textarea, $ = L.character;
      return b !== u.e && k(x, u.e = b), C !== u.t && ((u.t = C) != null ? x.style.setProperty("min-width", C) : x.style.removeProperty("min-width")), S !== u.a && ((u.a = S) != null ? x.style.setProperty("min-height", S) : x.style.removeProperty("min-height")), p !== u.o && k(A, u.o = p), $ !== u.i && k(h, u.i = $), u;
    }, {
      e: void 0,
      t: void 0,
      a: void 0,
      o: void 0,
      i: void 0
    }), E(() => A.value = t.value), g;
  })();
}
function ne(n) {
  return T(fe, {
    get when() {
      return n.node.type !== "text" && n.node;
    },
    get fallback() {
      return n.node.value;
    },
    children: (t) => T(Oe, Q({
      get component() {
        return t().tagName || "div";
      }
    }, () => t().properties, {
      get children() {
        return T(ae, {
          get each() {
            return t().children;
          },
          children: (e) => T(ne, {
            get node() {
              return e();
            }
          })
        });
      }
    }))
  });
}
z(["input"]);
export {
  it as ShikiTextarea
};
